(*
 * Test question 6
 *)

open Question6

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let rec gen_list accu = function
      0 -> accu
    | n when n>0 -> gen_list ((Random.int 256)::accu) (n-1)
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "%d; ") l;
    Printf.printf "]\n"
  in
  let usage = "Prog TP: question 6\nquestion6 graine taille1 position taille2" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size1::pos::size2::_ ->
	    Random.init seed;
	    let l1 = gen_list [] size1 in
	    let l2 = gen_list [] size2 in
	      Printf.printf "l1 = ";
	      print_int_list l1;
	      Printf.printf "l2 = ";
	      print_int_list l2;
	      Printf.printf "inject l1 %i l2 =" pos;
	      print_int_list (inject l1 pos l2);
	      exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
